import { APIUser, SearchAutoCompleteType } from './general';

export type RequestBase = {
	charset: 'UTF-8';
	format: 'json';
};

export type LoginRequest = RequestBase & {
	loginId: string;
	password: string;
};

export type LogoutRequest = RequestBase &
	APIUser & {
		compId: 1;
		compAuthKey: '2/Qb9R@8s*';
	};

export type GetMusicDetailRequest = RequestBase &
	APIUser & {
		compId: 1;
		compAuthKey: '2/Qb9R@8s*';
		deviceId: 22;
		requestNo: string;
		serviceId: 1;
		contractId: 1;
	};

export type GetMusicStreamingURLRequest = RequestBase &
	APIUser & {
		compId: 1;
		compAuthKey: '2/Qb9R@8s*';
		deviceId: 22;
		serviceId: 1;
		requestNo: string;
	};

export type GetMusicRankingTermRequest = RequestBase &
	APIUser & {
		compId: 1;
		compAuthKey: '2/Qb9R@8s*';
		dispNumber: 1000;
		pageNo: 1;
		targetContractId: 0;
		/**
		 * 202311
		 * YYYYmm
		 */
		targetStartDateFrom: number;
		targetStartDateTo: number;
		targetEndDateFrom: number;
		targetEndDateTo: number;
		sort: 1;
	};

export type GetMusicRankingRequest = RequestBase &
	APIUser & {
		compId: 1;
		compAuthKey: '2/Qb9R@8s*';
		dispNumber: 30;
		pageNo: number;
		targetContractId: 1;
		musicViewsRankingId: number;
		serviceId: 1;
		deviceId: 22;
		getCount: 200;
		thumbnailType: 1;
	};

export type SearchAutoCompleteRequest = APIUser & {
	authKey: '2/Qb9R@8s*';
	compId: 1;
	keyword: string;
	minseiModelNum: 'M1';
	modelTypeCode: 2;
	responseInfoType: SearchAutoCompleteType;
};

export type GetNewReleaseMusicRequest = RequestBase &
	APIUser & {
		compId: 1;
		compAuthKey: '2/Qb9R@8s*';
		deliveryRelativeWeek: 0;
		dispNumber: 30;
		pageNo: number;
		serviceId: 1;
		deviceId: 22;
		targetContractId: 1;
		thumbnailType: 1;
	};

export type SearchVariousByKeywordRequest = APIUser & {
	authKey: '2/Qb9R@8s*';
	compId: 1;
	dispCount: 30;
	keyword: string;
	minseiModelNum: 'M1';
	modelPatternCode: 0;
	modelTypeCode: 2;
	pageNo: number;
	shopType: '02';
	sort: 2;
};

export type SearchMusicByKeywordRequest = APIUser & {
	authKey: '2/Qb9R@8s*';
	compId: 1;
	dispCount: 30;
	keyword: string;
	minseiModelNum: 'M1';
	modelPatternCode: 1;
	modelTypeCode: 2;
	pageNo: number;
	shopType: '02';
	sort: 1;
};

export type SearchArtistByKeywordRequest = APIUser & {
	authKey: '2/Qb9R@8s*';
	compId: 1;
	dispCount: 30;
	keyword: string;
	minseiModelNum: 'M1';
	modelPatternCode: 1;
	modelTypeCode: 2;
	pageNo: number;
	shopType: '02';
	sort: 1;
};

export type GetMusicListByArtistRequest = APIUser & {
	artistCode: number;
	authKey: '2/Qb9R@8s*';
	compId: 1;
	dispCount: 30;
	minseiModelNum: 'M1';
	modelTypeCode: 2;
	pageNo: number;
	sort: 1;
};
